<#if view.hasPSControl('form')>
<#assign view_content>
        <component 
            :is="activeForm.name"
            :isautoload="true"
            :viewState="viewState"  
            :viewparams="viewparams" 
            :context="context" 
            :autosave="false" 
            :viewtag="viewtag"
            :showBusyIndicator="activeForm.showBusyIndicator"
            :updateAction="activeForm.updateAction"
            :removeAction="activeForm.removeAction"
            :loaddraftAction="activeForm.loaddraftAction"
            :loadAction="activeForm.loadAction"
            :createAction="activeForm.createAction"
            :WFSubmitAction="activeForm.WFSubmitAction"
            :WFStartAction="activeForm.WFStartAction"
            :srfwfmemo="srfwfmemo"
            name="form"  
            ref='form' 
            @save="form_save($event)"  
            @remove="form_remove($event)"  
            @load="form_load($event)"  
            @closeview="closeView($event)">
        </component>
</#assign>
<#assign view_footer>
    <div class="fab_container">
        <app-mob-button 
            v-if="linkModel.length > 0"  
            iconName="chevron-up-circle-outline"
            class="app-view-toolbar-button wf_btns" 
            :style="button_style"  
            @click="popUpGroup(true)"  />
        <van-popup  class="popup" v-model="showGrop" round position="bottom">
            <div class="container">
                <div class='sub-item'  v-for="(linkItem,index) in linkModel" :key="index" >
                <app-mob-button  
                    :text="linkItem.sequenceFlowName"
                    @click="dynamic_toolbar_click(linkItem, $event)" />
            </div>
            </div>
        </van-popup>
    </div>
</#assign>
</#if>
<#ibizinclude>
../@MACRO/ISOUTPUTTOOLBAR.ftl
</#ibizinclude>
<#ibizinclude>
../../../@NAVPARAMS/FUNC/PUBLIC.vue.ftl
</#ibizinclude>
<#if view.getPSSysCss?? && view.getPSSysCss()??>
<#assign styleName = view.getPSSysCss().getCssName()/>
</#if>
<#if styleName?? && styleName == "TopFullScreen">
<#assign isStyleName = true/>
<#else>
<#assign isStyleName = false/>
</#if>
<ion-page :className="{ 'view-container': true<#if !isStyleName>, 'default-mode-view': true</#if>, '${view.getViewType()?lower_case}': true, '${srffilepath2(view.getCodeName())}': true<#if view.getPSSysCss?? && view.getPSSysCss()??>, '${view.getPSSysCss().getCssName()}': true</#if> }">
    
    <app-mob-header>
    <#if !view.isShowCaptionBar?? || view.isShowCaptionBar() == true>
        <ion-toolbar v-show="titleStatus" class="ionoc-view-header">
            <ion-buttons slot="start">
                <app-mob-button 
                    v-show="isShowBackButton" 
                    ref="backbtn"
                    iconName="chevron-back" 
                    :text="$t('app.button.back')" 
                    @click="closeView" />
            </ion-buttons>
            <#if !view.isShowCaptionBar?? || view.isShowCaptionBar() == true><app-mob-title class="view-title"><label class="title-label"><app-mob-icon v-if="model.icon" :name="model.icon"></app-mob-icon> <img v-else-if="model.iconcls" :src="model.iconcls" alt=""> {{$t(model.srfCaption)}}</label></app-mob-title></#if>
        </ion-toolbar>
    </#if>
    </app-mob-header>
    <@ibizindent blank=8>
    <ion-content<#if isScroll??> :scroll-events="true" @ionScroll="onScroll" ref="ionScroll" @ionScrollEnd="onScrollEnd"</#if>>
    <#if view_content??>
        ${view_content}
    </#if>
    </@ibizindent>
    </ion-content>
<#--  输出底部工具栏或者底部内容：BEGIN  -->
<#if isOutputToolBar('MOBBOTTOMMENU') || view_footer??>
    <ion-footer class="view-footer">
    <#list view.getAllPSControls() as ctrl>
    <#if ctrl.getControlType() == 'TOOLBAR' && ctrl.getToolbarStyle?? && ctrl.getToolbarStyle() == 'MOBBOTTOMMENU'>
    <@ibizindent blank=8>
        ${P.getCtrlCode(ctrl,'CONTROL.html').code}
    </@ibizindent>
    </#if>
    </#list>
    <#if view_footer??>
        ${view_footer}
    </#if>
    </ion-footer>
</#if>
</ion-page>