<#assign self_content>
    /**
     * 加载模型
     * 
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public loadModel(){
    <#assign appDataEntity = view.getPSAppDataEntity() />
        if(this.context.${appDataEntity.getCodeName()?lower_case}){
            this.appEntityService.getDataInfo(JSON.parse(JSON.stringify(this.context)),{},false).then((response:any) =>{
                if (!response || response.status !== 200) {
                    return;
                }
                const { data: _data } = response;
                if (_data.${appDataEntity.getMajorPSAppDEField().getCodeName()?lower_case}) {
                    Object.assign(this.model, { dataInfo: _data.${appDataEntity.getMajorPSAppDEField().getCodeName()?lower_case} });
                    <#noparse>Object.assign(this.model, { srfCaption: `${this.$t(this.model.srfCaption)} - ${this.model.dataInfo}` });</#noparse>
                    this.$viewTool.setViewTitleOfThirdParty(this.$t(this.model.srfCaption) as string);
                }
            })
        }
    }
</#assign>

<#ibizinclude>
../@MACRO/LAYOUTPANEL_VIEW.template.ftl
</#ibizinclude>



<#ibizinclude>
../@MACRO/VIEW_HEADER-BASE.vue.ftl
</#ibizinclude>
<#if view.hasPSControl('tabexppanel')>
<#assign tabexppanel = view.getPSControl('tabexppanel')>
<#assign dename = tabexppanel.getPSAppDataEntity().getCodeName()?lower_case>
<#assign created_block>
        this.getCacheTabkey();
</#assign>

    /**
     * 计数器数据
     *
     * @type {string}
     * @memberof  ${srfclassname('${view.name}')}Base
     */
    public counter:any = {counterData:{}} ;


    /**
     * 计数器初始化
     *
     * @type {string}
     * @memberof  ${srfclassname('${view.name}')}Base
     */
    private counterInit(value:any) {
        this.counter = value;
    }

    /**
     * 被激活的分页面板
     *
     * @type {string}
     * @memberof  ${srfclassname('${view.name}')}Base
     */
    protected activiedTabViewPanel: string = '<#list tabexppanel.getPSControls() as tabviewpanel><#if tabviewpanel_index==0>${tabviewpanel.name}</#if></#list>';

    /**
     * 分页导航栏激活
     *
     * @param {*} $event
     * @returns {void}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public tabExpPanelChange($event: any): void {
        let { detail } = $event;
        if (!detail) {
            return;
        }
        let { value } = detail;
        if (!value) {
            return;
        }
        this.viewState.next({ tag: '${tabexppanel.name}', action: 'active', data: { activeItem: value } });
        this.setCacheTabkey(value);     
    }

    /**
     * 子传父修改激活的Panel
     *
     * @param {*} $event
     * @returns {void}
     * @memberof MOBORDERMobTabExpViewBase
     */
    protected changePanel(res:any) : void {
      this.activiedTabViewPanel = res;
    }
    /**
     * localStorage存值
     *
     * @param {*} $event
     * @returns {void}
     * @memberof MOBORDERMobTabExpViewBase
     */    
    public setCacheTabkey(value:any) {
        const cacheTab:any = {name:'${dename}',id:this.context.${dename},value:value,viewtag: this.viewtag};
        localStorage.setItem('tabKey',JSON.stringify(cacheTab));    
    }
    /**
     * localStorage取值
     *
     * @param {*} $event
     * @returns {void}
     * @memberof MOBORDERMobTabExpViewBase
     */
    public getCacheTabkey() {
        const _cacheTabKey: any = localStorage.getItem('tabKey')
        if(_cacheTabKey){
        let cacheTabKey:any = JSON.parse(_cacheTabKey);
        if (cacheTabKey.name && cacheTabKey.name == '${dename}' && cacheTabKey.id && cacheTabKey.id == this.context.${dename} && cacheTabKey.viewtag === this.viewtag) {
          this.activiedTabViewPanel = cacheTabKey.value;
        } else { 
          this.activiedTabViewPanel = '<#list tabexppanel.getPSControls() as tabviewpanel><#if tabviewpanel_index==0>${tabviewpanel.name}</#if></#list>';
        }
        }
    }

</#if>
<#ibizinclude>
../@MACRO/VIEW_CONTENT-BASE.vue.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/VIEW_BOTTOM-BASE.vue.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/VIEW-BASE.style.ftl
</#ibizinclude>